Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/molecules.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -2177,203 +2872,203 @@
  * \todo BFS from the not-same-LP to find back to starting point of tributary cycle over more than one bond
  */
-void molecule::CyclicStructureAnalysis(ofstream *out, class StackClass<bond *> *	BackEdgeStack, int *&MinimumRingSize)
-{
-	atom **PredecessorList = (atom **) Malloc(sizeof(atom *)*AtomCount, "molecule::CyclicStructureAnalysis: **PredecessorList");
-	int *ShortestPathList = (int *) Malloc(sizeof(int)*AtomCount, "molecule::CyclicStructureAnalysis: *ShortestPathList");
-	enum Shading *ColorList = (enum Shading *) Malloc(sizeof(enum Shading)*AtomCount, "molecule::CyclicStructureAnalysis: *ColorList");
-	class StackClass<atom *> *BFSStack = new StackClass<atom *> (AtomCount);	 // will hold the current ring
-	class StackClass<atom *> *TouchedStack = new StackClass<atom *> (AtomCount);	 // contains all "touched" atoms (that need to be reset after BFS loop)
-	atom *Walker = NULL, *OtherAtom = NULL, *Root = NULL;
-	bond *Binder = NULL, *BackEdge = NULL;
-	int RingSize, NumCycles, MinRingSize = -1;
-
-	// initialise each vertex as white with no predecessor, empty queue, color Root lightgray
-	for (int i=AtomCount;i--;) {
-		PredecessorList[i] = NULL;
-		ShortestPathList[i] = -1;
-		ColorList[i] = white;
-	}
-
-	*out << Verbose(1) << "Back edge list - ";
-	BackEdgeStack->Output(out);
-
-	*out << Verbose(1) << "Analysing cycles ... " << endl;
-	NumCycles = 0;
-	while (!BackEdgeStack->IsEmpty()) {
-		BackEdge = BackEdgeStack->PopFirst();
-		// this is the target
-		Root = BackEdge->leftatom;
-		// this is the source point
-		Walker = BackEdge->rightatom;
-		ShortestPathList[Walker->nr] = 0;
-		BFSStack->ClearStack();	// start with empty BFS stack
-		BFSStack->Push(Walker);
-		TouchedStack->Push(Walker);
-		*out << Verbose(1) << "---------------------------------------------------------------------------------------------------------" << endl;
-		OtherAtom = NULL;
-		do {	// look for Root
-			Walker = BFSStack->PopFirst();
-			*out << Verbose(2) << "Current Walker is " << *Walker << ", we look for SP to Root " << *Root << "." << endl;
-			for(int i=0;i<NumberOfBondsPerAtom[Walker->nr];i++) {
-				Binder = ListOfBondsPerAtom[Walker->nr][i];
-				if (Binder != BackEdge) { // only walk along DFS spanning tree (otherwise we always find SP of one being backedge Binder)
-					OtherAtom = Binder->GetOtherAtom(Walker);
+void molecule::CyclicStructureAnalysis(ofstream *out, class StackClass<bond *> *  BackEdgeStack, int *&MinimumRingSize)
+{
+  atom **PredecessorList = (atom **) Malloc(sizeof(atom *)*AtomCount, "molecule::CyclicStructureAnalysis: **PredecessorList");
+  int *ShortestPathList = (int *) Malloc(sizeof(int)*AtomCount, "molecule::CyclicStructureAnalysis: *ShortestPathList");
+  enum Shading *ColorList = (enum Shading *) Malloc(sizeof(enum Shading)*AtomCount, "molecule::CyclicStructureAnalysis: *ColorList");
+  class StackClass<atom *> *BFSStack = new StackClass<atom *> (AtomCount);   // will hold the current ring
+  class StackClass<atom *> *TouchedStack = new StackClass<atom *> (AtomCount);   // contains all "touched" atoms (that need to be reset after BFS loop)
+  atom *Walker = NULL, *OtherAtom = NULL, *Root = NULL;
+  bond *Binder = NULL, *BackEdge = NULL;
+  int RingSize, NumCycles, MinRingSize = -1;
+
+  // initialise each vertex as white with no predecessor, empty queue, color Root lightgray
+  for (int i=AtomCount;i--;) {
+    PredecessorList[i] = NULL;
+    ShortestPathList[i] = -1;
+    ColorList[i] = white;
+  }
+
+  *out << Verbose(1) << "Back edge list - ";
+  BackEdgeStack->Output(out);
+
+  *out << Verbose(1) << "Analysing cycles ... " << endl;
+  NumCycles = 0;
+  while (!BackEdgeStack->IsEmpty()) {
+    BackEdge = BackEdgeStack->PopFirst();
+    // this is the target
+    Root = BackEdge->leftatom;
+    // this is the source point
+    Walker = BackEdge->rightatom;
+    ShortestPathList[Walker->nr] = 0;
+    BFSStack->ClearStack();  // start with empty BFS stack
+    BFSStack->Push(Walker);
+    TouchedStack->Push(Walker);
+    *out << Verbose(1) << "---------------------------------------------------------------------------------------------------------" << endl;
+    OtherAtom = NULL;
+    do {  // look for Root
+      Walker = BFSStack->PopFirst();
+      *out << Verbose(2) << "Current Walker is " << *Walker << ", we look for SP to Root " << *Root << "." << endl;
+      for(int i=0;i<NumberOfBondsPerAtom[Walker->nr];i++) {
+        Binder = ListOfBondsPerAtom[Walker->nr][i];
+        if (Binder != BackEdge) { // only walk along DFS spanning tree (otherwise we always find SP of one being backedge Binder)
+          OtherAtom = Binder->GetOtherAtom(Walker);
 #ifdef ADDHYDROGEN
-					if (OtherAtom->type->Z != 1) {
+          if (OtherAtom->type->Z != 1) {
 #endif
-						*out << Verbose(2) << "Current OtherAtom is: " << OtherAtom->Name << " for bond " << *Binder << "." << endl;
-						if (ColorList[OtherAtom->nr] == white) {
-							TouchedStack->Push(OtherAtom);
-							ColorList[OtherAtom->nr] = lightgray;
-							PredecessorList[OtherAtom->nr] = Walker;	// Walker is the predecessor
-							ShortestPathList[OtherAtom->nr] = ShortestPathList[Walker->nr]+1;
-							*out << Verbose(2) << "Coloring OtherAtom " << OtherAtom->Name << " lightgray, its predecessor is " << Walker->Name << " and its Shortest Path is " << ShortestPathList[OtherAtom->nr] << " egde(s) long." << endl;
-							//if (ShortestPathList[OtherAtom->nr] < MinimumRingSize[Walker->GetTrueFather()->nr]) { // Check for maximum distance
-								*out << Verbose(3) << "Putting OtherAtom into queue." << endl;
-								BFSStack->Push(OtherAtom);
-							//}
-						} else {
-							*out << Verbose(3) << "Not Adding, has already been visited." << endl;
-						}
-						if (OtherAtom == Root)
-							break;
+            *out << Verbose(2) << "Current OtherAtom is: " << OtherAtom->Name << " for bond " << *Binder << "." << endl;
+            if (ColorList[OtherAtom->nr] == white) {
+              TouchedStack->Push(OtherAtom);
+              ColorList[OtherAtom->nr] = lightgray;
+              PredecessorList[OtherAtom->nr] = Walker;  // Walker is the predecessor
+              ShortestPathList[OtherAtom->nr] = ShortestPathList[Walker->nr]+1;
+              *out << Verbose(2) << "Coloring OtherAtom " << OtherAtom->Name << " lightgray, its predecessor is " << Walker->Name << " and its Shortest Path is " << ShortestPathList[OtherAtom->nr] << " egde(s) long." << endl;
+              //if (ShortestPathList[OtherAtom->nr] < MinimumRingSize[Walker->GetTrueFather()->nr]) { // Check for maximum distance
+                *out << Verbose(3) << "Putting OtherAtom into queue." << endl;
+                BFSStack->Push(OtherAtom);
+              //}
+            } else {
+              *out << Verbose(3) << "Not Adding, has already been visited." << endl;
+            }
+            if (OtherAtom == Root)
+              break;
 #ifdef ADDHYDROGEN
-					} else {
-						*out << Verbose(2) << "Skipping hydrogen atom " << *OtherAtom << "." << endl;
-						ColorList[OtherAtom->nr] = black;
-					}
+          } else {
+            *out << Verbose(2) << "Skipping hydrogen atom " << *OtherAtom << "." << endl;
+            ColorList[OtherAtom->nr] = black;
+          }
 #endif
-				} else {
-					*out << Verbose(2) << "Bond " << *Binder << " not Visiting, is the back edge." << endl;
-				}
-			}
-			ColorList[Walker->nr] = black;
-			*out << Verbose(1) << "Coloring Walker " << Walker->Name << " black." << endl;
-			if (OtherAtom == Root) { // if we have found the root, check whether this cycle wasn't already found beforehand
-				// step through predecessor list
-				while (OtherAtom != BackEdge->rightatom) {
-					if (!OtherAtom->GetTrueFather()->IsCyclic)	// if one bond in the loop is not marked as cyclic, we haven't found this cycle yet
-						break;
-					else
-						OtherAtom = PredecessorList[OtherAtom->nr];
-				}
-				if (OtherAtom == BackEdge->rightatom) { // if each atom in found cycle is cyclic, loop's been found before already
-					*out << Verbose(3) << "This cycle was already found before, skipping and removing seeker from search." << endl;\
-					do {
-						OtherAtom = TouchedStack->PopLast();
-						if (PredecessorList[OtherAtom->nr] == Walker) {
-							*out << Verbose(4) << "Removing " << *OtherAtom << " from lists and stacks." << endl;
-							PredecessorList[OtherAtom->nr] = NULL;
-							ShortestPathList[OtherAtom->nr] = -1;
-							ColorList[OtherAtom->nr] = white;
-							BFSStack->RemoveItem(OtherAtom);
-						}
-					} while ((!TouchedStack->IsEmpty()) && (PredecessorList[OtherAtom->nr] == NULL));
-					TouchedStack->Push(OtherAtom);	// last was wrongly popped
-					OtherAtom = BackEdge->rightatom; // set to not Root
-				} else
-					OtherAtom = Root;
-			}
-		} while ((!BFSStack->IsEmpty()) && (OtherAtom != Root) && (OtherAtom != NULL)); // || (ShortestPathList[OtherAtom->nr] < MinimumRingSize[Walker->GetTrueFather()->nr])));
-
-		if (OtherAtom == Root) {
-			// now climb back the predecessor list and thus find the cycle members
-			NumCycles++;
-			RingSize = 1;
-			Root->GetTrueFather()->IsCyclic = true;
-			*out << Verbose(1) << "Found ring contains: ";
-			Walker = Root;
-			while (Walker != BackEdge->rightatom) {
-				*out << Walker->Name << " <-> ";
-				Walker = PredecessorList[Walker->nr];
-				Walker->GetTrueFather()->IsCyclic = true;
-				RingSize++;
-			}
-			*out << Walker->Name << "	with a length of " << RingSize << "." << endl << endl;
-			// walk through all and set MinimumRingSize
-			Walker = Root;
-			MinimumRingSize[Walker->GetTrueFather()->nr] = RingSize;
-			while (Walker != BackEdge->rightatom) {
-				Walker = PredecessorList[Walker->nr];
-				if (RingSize < MinimumRingSize[Walker->GetTrueFather()->nr])
-					MinimumRingSize[Walker->GetTrueFather()->nr] = RingSize;
-			}
-			if ((RingSize < MinRingSize) || (MinRingSize == -1))
-				MinRingSize = RingSize;
-		} else {
-			*out << Verbose(1) << "No ring containing " << *Root << " with length equal to or smaller than " << MinimumRingSize[Walker->GetTrueFather()->nr] << " found." << endl;
-		}
-
-		// now clean the lists
-		while (!TouchedStack->IsEmpty()){
-			Walker = TouchedStack->PopFirst();
-			PredecessorList[Walker->nr] = NULL;
-			ShortestPathList[Walker->nr] = -1;
-			ColorList[Walker->nr] = white;
-		}
-	}
-	if (MinRingSize != -1) {
-		// go over all atoms
-		Root = start;
-		while(Root->next != end) {
-			Root = Root->next;
-
-			if (MinimumRingSize[Root->GetTrueFather()->nr] == AtomCount) { // check whether MinimumRingSize is set, if not BFS to next where it is
-				Walker = Root;
-				ShortestPathList[Walker->nr] = 0;
-				BFSStack->ClearStack();	// start with empty BFS stack
-				BFSStack->Push(Walker);
-				TouchedStack->Push(Walker);
-				//*out << Verbose(1) << "---------------------------------------------------------------------------------------------------------" << endl;
-				OtherAtom = Walker;
-				while (OtherAtom != NULL) {	// look for Root
-					Walker = BFSStack->PopFirst();
-					//*out << Verbose(2) << "Current Walker is " << *Walker << ", we look for SP to Root " << *Root << "." << endl;
-					for(int i=0;i<NumberOfBondsPerAtom[Walker->nr];i++) {
-						Binder = ListOfBondsPerAtom[Walker->nr][i];
-						if ((Binder != BackEdge) || (NumberOfBondsPerAtom[Walker->nr] == 1)) { // only walk along DFS spanning tree (otherwise we always find SP of 1 being backedge Binder), but terminal hydrogens may be connected via backedge, hence extra check
-							OtherAtom = Binder->GetOtherAtom(Walker);
-							//*out << Verbose(2) << "Current OtherAtom is: " << OtherAtom->Name << " for bond " << *Binder << "." << endl;
-							if (ColorList[OtherAtom->nr] == white) {
-								TouchedStack->Push(OtherAtom);
-								ColorList[OtherAtom->nr] = lightgray;
-								PredecessorList[OtherAtom->nr] = Walker;	// Walker is the predecessor
-								ShortestPathList[OtherAtom->nr] = ShortestPathList[Walker->nr]+1;
-								//*out << Verbose(2) << "Coloring OtherAtom " << OtherAtom->Name << " lightgray, its predecessor is " << Walker->Name << " and its Shortest Path is " << ShortestPathList[OtherAtom->nr] << " egde(s) long." << endl;
-								if (OtherAtom->GetTrueFather()->IsCyclic) { // if the other atom is connected to a ring
-									MinimumRingSize[Root->GetTrueFather()->nr] = ShortestPathList[OtherAtom->nr]+MinimumRingSize[OtherAtom->GetTrueFather()->nr];
-									OtherAtom = NULL; //break;
-									break;
-								} else
-									BFSStack->Push(OtherAtom);
-							} else {
-								//*out << Verbose(3) << "Not Adding, has already been visited." << endl;
-							}
-						} else {
-							//*out << Verbose(3) << "Not Visiting, is a back edge." << endl;
-						}
-					}
-					ColorList[Walker->nr] = black;
-					//*out << Verbose(1) << "Coloring Walker " << Walker->Name << " black." << endl;
-				}
-
-				// now clean the lists
-				while (!TouchedStack->IsEmpty()){
-					Walker = TouchedStack->PopFirst();
-					PredecessorList[Walker->nr] = NULL;
-					ShortestPathList[Walker->nr] = -1;
-					ColorList[Walker->nr] = white;
-				}
-			}
-			*out << Verbose(1) << "Minimum ring size of " << *Root << " is " << MinimumRingSize[Root->GetTrueFather()->nr] << "." << endl;
-		}
-		*out << Verbose(1) << "Minimum ring size is " << MinRingSize << ", over " << NumCycles << " cycles total." << endl;
-	} else
-		*out << Verbose(1) << "No rings were detected in the molecular structure." << endl;
-
-	Free((void **)&PredecessorList, "molecule::CyclicStructureAnalysis: **PredecessorList");
-	Free((void **)&ShortestPathList, "molecule::CyclicStructureAnalysis: **ShortestPathList");
-	Free((void **)&ColorList, "molecule::CyclicStructureAnalysis: **ColorList");
-	delete(BFSStack);
+        } else {
+          *out << Verbose(2) << "Bond " << *Binder << " not Visiting, is the back edge." << endl;
+        }
+      }
+      ColorList[Walker->nr] = black;
+      *out << Verbose(1) << "Coloring Walker " << Walker->Name << " black." << endl;
+      if (OtherAtom == Root) { // if we have found the root, check whether this cycle wasn't already found beforehand
+        // step through predecessor list
+        while (OtherAtom != BackEdge->rightatom) {
+          if (!OtherAtom->GetTrueFather()->IsCyclic)  // if one bond in the loop is not marked as cyclic, we haven't found this cycle yet
+            break;
+          else
+            OtherAtom = PredecessorList[OtherAtom->nr];
+        }
+        if (OtherAtom == BackEdge->rightatom) { // if each atom in found cycle is cyclic, loop's been found before already
+          *out << Verbose(3) << "This cycle was already found before, skipping and removing seeker from search." << endl;\
+          do {
+            OtherAtom = TouchedStack->PopLast();
+            if (PredecessorList[OtherAtom->nr] == Walker) {
+              *out << Verbose(4) << "Removing " << *OtherAtom << " from lists and stacks." << endl;
+              PredecessorList[OtherAtom->nr] = NULL;
+              ShortestPathList[OtherAtom->nr] = -1;
+              ColorList[OtherAtom->nr] = white;
+              BFSStack->RemoveItem(OtherAtom);
+            }
+          } while ((!TouchedStack->IsEmpty()) && (PredecessorList[OtherAtom->nr] == NULL));
+          TouchedStack->Push(OtherAtom);  // last was wrongly popped
+          OtherAtom = BackEdge->rightatom; // set to not Root
+        } else
+          OtherAtom = Root;
+      }
+    } while ((!BFSStack->IsEmpty()) && (OtherAtom != Root) && (OtherAtom != NULL)); // || (ShortestPathList[OtherAtom->nr] < MinimumRingSize[Walker->GetTrueFather()->nr])));
+
+    if (OtherAtom == Root) {
+      // now climb back the predecessor list and thus find the cycle members
+      NumCycles++;
+      RingSize = 1;
+      Root->GetTrueFather()->IsCyclic = true;
+      *out << Verbose(1) << "Found ring contains: ";
+      Walker = Root;
+      while (Walker != BackEdge->rightatom) {
+        *out << Walker->Name << " <-> ";
+        Walker = PredecessorList[Walker->nr];
+        Walker->GetTrueFather()->IsCyclic = true;
+        RingSize++;
+      }
+      *out << Walker->Name << "  with a length of " << RingSize << "." << endl << endl;
+      // walk through all and set MinimumRingSize
+      Walker = Root;
+      MinimumRingSize[Walker->GetTrueFather()->nr] = RingSize;
+      while (Walker != BackEdge->rightatom) {
+        Walker = PredecessorList[Walker->nr];
+        if (RingSize < MinimumRingSize[Walker->GetTrueFather()->nr])
+          MinimumRingSize[Walker->GetTrueFather()->nr] = RingSize;
+      }
+      if ((RingSize < MinRingSize) || (MinRingSize == -1))
+        MinRingSize = RingSize;
+    } else {
+      *out << Verbose(1) << "No ring containing " << *Root << " with length equal to or smaller than " << MinimumRingSize[Walker->GetTrueFather()->nr] << " found." << endl;
+    }
+
+    // now clean the lists
+    while (!TouchedStack->IsEmpty()){
+      Walker = TouchedStack->PopFirst();
+      PredecessorList[Walker->nr] = NULL;
+      ShortestPathList[Walker->nr] = -1;
+      ColorList[Walker->nr] = white;
+    }
+  }
+  if (MinRingSize != -1) {
+    // go over all atoms
+    Root = start;
+    while(Root->next != end) {
+      Root = Root->next;
+
+      if (MinimumRingSize[Root->GetTrueFather()->nr] == AtomCount) { // check whether MinimumRingSize is set, if not BFS to next where it is
+        Walker = Root;
+        ShortestPathList[Walker->nr] = 0;
+        BFSStack->ClearStack();  // start with empty BFS stack
+        BFSStack->Push(Walker);
+        TouchedStack->Push(Walker);
+        //*out << Verbose(1) << "---------------------------------------------------------------------------------------------------------" << endl;
+        OtherAtom = Walker;
+        while (OtherAtom != NULL) {  // look for Root
+          Walker = BFSStack->PopFirst();
+          //*out << Verbose(2) << "Current Walker is " << *Walker << ", we look for SP to Root " << *Root << "." << endl;
+          for(int i=0;i<NumberOfBondsPerAtom[Walker->nr];i++) {
+            Binder = ListOfBondsPerAtom[Walker->nr][i];
+            if ((Binder != BackEdge) || (NumberOfBondsPerAtom[Walker->nr] == 1)) { // only walk along DFS spanning tree (otherwise we always find SP of 1 being backedge Binder), but terminal hydrogens may be connected via backedge, hence extra check
+              OtherAtom = Binder->GetOtherAtom(Walker);
+              //*out << Verbose(2) << "Current OtherAtom is: " << OtherAtom->Name << " for bond " << *Binder << "." << endl;
+              if (ColorList[OtherAtom->nr] == white) {
+                TouchedStack->Push(OtherAtom);
+                ColorList[OtherAtom->nr] = lightgray;
+                PredecessorList[OtherAtom->nr] = Walker;  // Walker is the predecessor
+                ShortestPathList[OtherAtom->nr] = ShortestPathList[Walker->nr]+1;
+                //*out << Verbose(2) << "Coloring OtherAtom " << OtherAtom->Name << " lightgray, its predecessor is " << Walker->Name << " and its Shortest Path is " << ShortestPathList[OtherAtom->nr] << " egde(s) long." << endl;
+                if (OtherAtom->GetTrueFather()->IsCyclic) { // if the other atom is connected to a ring
+                  MinimumRingSize[Root->GetTrueFather()->nr] = ShortestPathList[OtherAtom->nr]+MinimumRingSize[OtherAtom->GetTrueFather()->nr];
+                  OtherAtom = NULL; //break;
+                  break;
+                } else
+                  BFSStack->Push(OtherAtom);
+              } else {
+                //*out << Verbose(3) << "Not Adding, has already been visited." << endl;
+              }
+            } else {
+              //*out << Verbose(3) << "Not Visiting, is a back edge." << endl;
+            }
+          }
+          ColorList[Walker->nr] = black;
+          //*out << Verbose(1) << "Coloring Walker " << Walker->Name << " black." << endl;
+        }
+
+        // now clean the lists
+        while (!TouchedStack->IsEmpty()){
+          Walker = TouchedStack->PopFirst();
+          PredecessorList[Walker->nr] = NULL;
+          ShortestPathList[Walker->nr] = -1;
+          ColorList[Walker->nr] = white;
+        }
+      }
+      *out << Verbose(1) << "Minimum ring size of " << *Root << " is " << MinimumRingSize[Root->GetTrueFather()->nr] << "." << endl;
+    }
+    *out << Verbose(1) << "Minimum ring size is " << MinRingSize << ", over " << NumCycles << " cycles total." << endl;
+  } else
+    *out << Verbose(1) << "No rings were detected in the molecular structure." << endl;
+
+  Free((void **)&PredecessorList, "molecule::CyclicStructureAnalysis: **PredecessorList");
+  Free((void **)&ShortestPathList, "molecule::CyclicStructureAnalysis: **ShortestPathList");
+  Free((void **)&ColorList, "molecule::CyclicStructureAnalysis: **ColorList");
+  delete(BFSStack);
 };
 
@@ -2385,18 +3080,18 @@
 void molecule::SetNextComponentNumber(atom *vertex, int nr)
 {
-	int i=0;
-	if (vertex != NULL) {
-		for(;i<NumberOfBondsPerAtom[vertex->nr];i++) {
-			if (vertex->ComponentNr[i] == -1) {	 // check if not yet used
-				vertex->ComponentNr[i] = nr;
-				break;
-			}
-			else if (vertex->ComponentNr[i] == nr) // if number is already present, don't add another time
-				break;	// breaking here will not cause error!
-		}
-		if (i == NumberOfBondsPerAtom[vertex->nr])
-			cerr << "Error: All Component entries are already occupied!" << endl;
-	} else
-			cerr << "Error: Given vertex is NULL!" << endl;
+  int i=0;
+  if (vertex != NULL) {
+    for(;i<NumberOfBondsPerAtom[vertex->nr];i++) {
+      if (vertex->ComponentNr[i] == -1) {   // check if not yet used
+        vertex->ComponentNr[i] = nr;
+        break;
+      }
+      else if (vertex->ComponentNr[i] == nr) // if number is already present, don't add another time
+        break;  // breaking here will not cause error!
+    }
+    if (i == NumberOfBondsPerAtom[vertex->nr])
+      cerr << "Error: All Component entries are already occupied!" << endl;
+  } else
+      cerr << "Error: Given vertex is NULL!" << endl;
 };
 
@@ -2406,6 +3101,6 @@
 void molecule::OutputComponentNumber(ofstream *out, atom *vertex)
 {
-	for(int i=0;i<NumberOfBondsPerAtom[vertex->nr];i++)
-		*out << vertex->ComponentNr[i] << "	";
+  for(int i=0;i<NumberOfBondsPerAtom[vertex->nr];i++)
+    *out << vertex->ComponentNr[i] << "  ";
 };
 
@@ -2414,13 +3109,13 @@
 void molecule::InitComponentNumbers()
 {
-	atom *Walker = start;
-	while(Walker->next != end) {
-		Walker = Walker->next;
-		if (Walker->ComponentNr != NULL)
-			Free((void **)&Walker->ComponentNr, "molecule::InitComponentNumbers: **Walker->ComponentNr");
-		Walker->ComponentNr = (int *) Malloc(sizeof(int)*NumberOfBondsPerAtom[Walker->nr], "molecule::InitComponentNumbers: *Walker->ComponentNr");
-		for (int i=NumberOfBondsPerAtom[Walker->nr];i--;)
-			Walker->ComponentNr[i] = -1;
-	}
+  atom *Walker = start;
+  while(Walker->next != end) {
+    Walker = Walker->next;
+    if (Walker->ComponentNr != NULL)
+      Free((void **)&Walker->ComponentNr, "molecule::InitComponentNumbers: **Walker->ComponentNr");
+    Walker->ComponentNr = (int *) Malloc(sizeof(int)*NumberOfBondsPerAtom[Walker->nr], "molecule::InitComponentNumbers: *Walker->ComponentNr");
+    for (int i=NumberOfBondsPerAtom[Walker->nr];i--;)
+      Walker->ComponentNr[i] = -1;
+  }
 };
 
@@ -2431,8 +3126,8 @@
 bond * molecule::FindNextUnused(atom *vertex)
 {
-	for(int i=0;i<NumberOfBondsPerAtom[vertex->nr];i++)
-		if (ListOfBondsPerAtom[vertex->nr][i]->IsUsed() == white)
-			return(ListOfBondsPerAtom[vertex->nr][i]);
-	return NULL;
+  for(int i=0;i<NumberOfBondsPerAtom[vertex->nr];i++)
+    if (ListOfBondsPerAtom[vertex->nr][i]->IsUsed() == white)
+      return(ListOfBondsPerAtom[vertex->nr][i]);
+  return NULL;
 };
 
@@ -2442,9 +3137,9 @@
 void molecule::ResetAllBondsToUnused()
 {
-	bond *Binder = first;
-	while (Binder->next != last) {
-		Binder = Binder->next;
-		Binder->ResetUsed();
-	}
+  bond *Binder = first;
+  while (Binder->next != last) {
+    Binder = Binder->next;
+    Binder->ResetUsed();
+  }
 };
 
@@ -2453,9 +3148,9 @@
 void molecule::ResetAllAtomNumbers()
 {
-	atom *Walker = start;
-	while (Walker->next != end) {
-		Walker = Walker->next;
-		Walker->GraphNr	= -1;
-	}
+  atom *Walker = start;
+  while (Walker->next != end) {
+    Walker = Walker->next;
+    Walker->GraphNr  = -1;
+  }
 };
 
@@ -2466,7 +3161,7 @@
 void OutputAlreadyVisited(ofstream *out, int *list)
 {
-	*out << Verbose(4) << "Already Visited Bonds:\t";
-	for(int i=1;i<=list[0];i++) *out << Verbose(0) << list[i] << "	";
-	*out << endl;
+  *out << Verbose(4) << "Already Visited Bonds:\t";
+  for(int i=1;i<=list[0];i++) *out << Verbose(0) << list[i] << "  ";
+  *out << endl;
 };
 
@@ -2474,5 +3169,5 @@
  * The upper limit is
  * \f[
- *	n = N \cdot C^k
+ *  n = N \cdot C^k
  * \f]
  * where \f$C=2^c\f$ and c is the maximum bond degree over N number of atoms.
@@ -2483,15 +3178,15 @@
 int molecule::GuesstimateFragmentCount(ofstream *out, int order)
 {
-	int c = 0;
-	int FragmentCount;
-	// get maximum bond degree
-	atom *Walker = start;
-	while (Walker->next != end) {
-		Walker = Walker->next;
-		c = (NumberOfBondsPerAtom[Walker->nr] > c) ? NumberOfBondsPerAtom[Walker->nr] : c;
-	}
-	FragmentCount = NoNonHydrogen*(1 << (c*order));
-	*out << Verbose(1) << "Upper limit for this subgraph is " << FragmentCount << " for " << NoNonHydrogen << " non-H atoms with maximum bond degree of " << c << "." << endl;
-	return FragmentCount;
+  int c = 0;
+  int FragmentCount;
+  // get maximum bond degree
+  atom *Walker = start;
+  while (Walker->next != end) {
+    Walker = Walker->next;
+    c = (NumberOfBondsPerAtom[Walker->nr] > c) ? NumberOfBondsPerAtom[Walker->nr] : c;
+  }
+  FragmentCount = NoNonHydrogen*(1 << (c*order));
+  *out << Verbose(1) << "Upper limit for this subgraph is " << FragmentCount << " for " << NoNonHydrogen << " non-H atoms with maximum bond degree of " << c << "." << endl;
+  return FragmentCount;
 };
 
@@ -2504,22 +3199,22 @@
 bool molecule::ScanBufferIntoKeySet(ofstream *out, char *buffer, KeySet &CurrentSet)
 {
-	stringstream line;
-	int AtomNr;
-	int status = 0;
-
-	line.str(buffer);
-	while (!line.eof()) {
-		line >> AtomNr;
-		if ((AtomNr >= 0) && (AtomNr < AtomCount)) {
-			CurrentSet.insert(AtomNr);	// insert at end, hence in same order as in file!
-			status++;
-		} // else it's "-1" or else and thus must not be added
-	}
-	*out << Verbose(1) << "The scanned KeySet is ";
-	for(KeySet::iterator runner = CurrentSet.begin(); runner != CurrentSet.end(); runner++) {
-		*out << (*runner) << "\t";
-	}
-	*out << endl;
-	return (status != 0);
+  stringstream line;
+  int AtomNr;
+  int status = 0;
+
+  line.str(buffer);
+  while (!line.eof()) {
+    line >> AtomNr;
+    if ((AtomNr >= 0) && (AtomNr < AtomCount)) {
+      CurrentSet.insert(AtomNr);  // insert at end, hence in same order as in file!
+      status++;
+    } // else it's "-1" or else and thus must not be added
+  }
+  *out << Verbose(1) << "The scanned KeySet is ";
+  for(KeySet::iterator runner = CurrentSet.begin(); runner != CurrentSet.end(); runner++) {
+    *out << (*runner) << "\t";
+  }
+  *out << endl;
+  return (status != 0);
 };
 
